searchNodes=[{"doc":"Client library for Sanity CMS. See the README for examples.","ref":"Sanity.html","title":"Sanity","type":"module"},{"doc":"Generates a request for the Doc endpoint . The Sanity docs suggest using this endpoint sparingly because it is &quot;less scalable/performant&quot; than using query/3 .","ref":"Sanity.html#doc/1","title":"Sanity.doc/1","type":"function"},{"doc":"Generates a request for the Mutate endpoint. Examples Sanity . mutate ( [ %{ create : %{ _type : &quot;product&quot; , title : &quot;Test product&quot; } } ] , return_ids : true ) |&gt; Sanity . request ( config )","ref":"Sanity.html#mutate/2","title":"Sanity.mutate/2","type":"function"},{"doc":"Generates a request to the Query endpoint. Requests to this endpoint may be authenticated or unauthenticated. Unauthenticated requests to a dataset with private visibility will succeed but will not return any documents.","ref":"Sanity.html#query/3","title":"Sanity.query/3","type":"function"},{"doc":"Replaces Sanity references with the referenced document. The input can be a single document or list of documents. References can be deeply nested within the documents. Documents can have either atom or string keys. Examples iex&gt; Sanity . replace_references ( %{ _ref : &quot;abc&quot; , _type : &quot;reference&quot; } , fn &quot;abc&quot; -&gt; %{ _id : &quot;abc&quot; } end ) %{ _id : &quot;abc&quot; } iex&gt; Sanity . replace_references ( %{ &quot;_ref&quot; =&gt; &quot;abc&quot; , &quot;_type&quot; =&gt; &quot;reference&quot; } , fn &quot;abc&quot; -&gt; %{ &quot;_id&quot; =&gt; &quot;abc&quot; } end ) %{ &quot;_id&quot; =&gt; &quot;abc&quot; } iex&gt; Sanity . replace_references ( %{ _ref : &quot;abc&quot; } , fn &quot;abc&quot; -&gt; %{ _id : &quot;abc&quot; } end ) %{ _id : &quot;abc&quot; } iex&gt; Sanity . replace_references ( %{ &quot;_ref&quot; =&gt; &quot;abc&quot; } , fn &quot;abc&quot; -&gt; %{ &quot;_id&quot; =&gt; &quot;abc&quot; } end ) %{ &quot;_id&quot; =&gt; &quot;abc&quot; } iex&gt; Sanity . replace_references ( [ %{ _ref : &quot;abc&quot; , _type : &quot;reference&quot; } ] , fn _ -&gt; %{ _id : &quot;abc&quot; } end ) [ %{ _id : &quot;abc&quot; } ] iex&gt; Sanity . replace_references ( [ %{ a : %{ _ref : &quot;abc&quot; , _type : &quot;reference&quot; } , b : 1 } ] , fn _ -&gt; %{ _id : &quot;abc&quot; } end ) [ %{ a : %{ _id : &quot;abc&quot; } , b : 1 } ]","ref":"Sanity.html#replace_references/2","title":"Sanity.replace_references/2","type":"function"},{"doc":"Submits a request to the Sanity API. Returns {:ok, response} upon success or {:error, response} if a non-exceptional (4xx) error occurs. A Sanity.Error will be raised if an exceptional error, such as a 5xx response code or a network timeout, occurs. Options :api_version - The default value is &quot;v2021-10-21&quot; . :cdn - Should the CDN be used? See the Sanity docs for details. The default value is false . :dataset - Sanity dataset. :http_options - Options to be passed to Finch.request/3 . The default value is [receive_timeout: 30000] . :max_attempts - Number of attempts to make before returning error. Requests receiving an HTTP status code of 4xx will not be retried. The default value is 1 . :project_id - Sanity project ID. :retry_delay - Delay in ms to wait before retrying after an error. Applies if max_attempts is greater than 1 . The default value is 1000 . :token - Sanity auth token.","ref":"Sanity.html#request/2","title":"Sanity.request/2","type":"function"},{"doc":"Like request/2 , but raises a Sanity.Error instead of returning and error tuple. See request/2 for supported options.","ref":"Sanity.html#request!/2","title":"Sanity.request!/2","type":"function"},{"doc":"Returns the result from a Sanity.Response struct. Examples iex&gt; Sanity . result! ( % Sanity.Response { body : %{ &quot;result&quot; =&gt; [ ] } } ) [ ] iex&gt; Sanity . result! ( % Sanity.Response { body : %{ } , status : 200 } ) ** (Sanity.Error) %Sanity.Response{body: %{}, headers: nil, status: 200}","ref":"Sanity.html#result!/1","title":"Sanity.result!/1","type":"function"},{"doc":"Returns a lazy Stream of results for the given query. The implementation is efficient and suitable for iterating over very large datasets. It is based on the Paginating with GROQ article from the Sanity docs. Failed attempts to fetch a batch will be retried by default. If the max attempts are exceeded then an exception will be raised as descrbied in request!/2 . The current implementation always sorts by ascending _id . Support for sorting by other fields may be supported in the future. Options :batch_size - Number of results to fetch per request. The Sanity docs say: &quot;In the general case, we recommend a batch size of no more than 5,000. If your documents are very large, a smaller batch size is better.&quot; The default value is 1000 . :drafts - Use :exclude to exclude drafts, :include to include drafts along with published docs, or :only to fetch drafts and not published documents. The default value is :exclude . :projection - GROQ projection. Must include the _id field. The default value is &quot;{ ... }&quot; . :query - Query string, like _type == &quot;page&quot; . By default, all documents will be selected. :request_opts - Required. Options to be passed to request/2 . If max_attempts is omitted then it will default to 3 . :variables - Map of variables to be used with query . The default value is %{} .","ref":"Sanity.html#stream/1","title":"Sanity.stream/1","type":"function"},{"doc":"Generates a request for the asset endpoint . Options :asset_type - Either :image or :file . The default value is :image . :content_type - Optional content-type header. It appears that Sanity is able to infer image types. Query params Sanity doesn't document the query params very well at this time, but the Sanity Javascript client lists several possible query params: label - Label title - Title description - Description filename - Original filename meta - ??? creditLine - The credit to person(s) and/or organization(s) required by the supplier of the image to be used when published","ref":"Sanity.html#upload_asset/3","title":"Sanity.upload_asset/3","type":"function"},{"doc":"Behaviour implemented by the Sanity module. This behaviour includes all functions that make requests to the Sanity API. Pure functions from the Sanity module are not included. This behaviour is useful for creating mocks using the Mox library.","ref":"Sanity.Behaviour.html","title":"Sanity.Behaviour","type":"behaviour"},{"doc":"","ref":"Sanity.Behaviour.html#c:request/2","title":"Sanity.Behaviour.request/2","type":"callback"},{"doc":"","ref":"Sanity.Behaviour.html#c:request!/2","title":"Sanity.Behaviour.request!/2","type":"callback"},{"doc":"","ref":"Sanity.Behaviour.html#c:stream/1","title":"Sanity.Behaviour.stream/1","type":"callback"},{"doc":"","ref":"Sanity.Request.html","title":"Sanity.Request","type":"module"},{"doc":"","ref":"Sanity.Request.html#t:t/0","title":"Sanity.Request.t/0","type":"type"},{"doc":"","ref":"Sanity.Response.html","title":"Sanity.Response","type":"module"},{"doc":"","ref":"Sanity.Response.html#t:t/0","title":"Sanity.Response.t/0","type":"type"},{"doc":"Error that may occur while making a request to the Sanity API. The source field will be one of the following: %Finch.Response{} - If response with an unsupported HTTP status (like 5xx) is received. %Mint.TransportError{} - If a network error such as a timeout occurred. %Sanity.Response{} - If a 4xx response is received during a call to Sanity.request!/2 .","ref":"Sanity.Error.html","title":"Sanity.Error","type":"exception"},{"doc":"A client library for the Sanity CMS API .","ref":"readme.html","title":"Sanity","type":"extras"},{"doc":"The package can be installed by adding sanity to your list of dependencies in mix.exs : def deps do [ { :sanity , &quot;~&gt; 0.12&quot; } ] end","ref":"readme.html#installation","title":"Sanity - Installation","type":"extras"},{"doc":"Sanity . query ( ~S&#39;*[_type == &quot;product&quot;]&#39; ) |&gt; Sanity . request ( project_id : &quot;abc&quot; , dataset : &quot;production&quot; )","ref":"readme.html#examples","title":"Sanity - Examples","type":"extras"},{"doc":"cms - An experimental library for syncing content from any headless CMS to ETS tables. sanity_components - Phoenix components for rendering images and portable text . sanity_sync - For syncing content from Sanity CMS to Ecto.","ref":"readme.html#related-projects","title":"Sanity - Related Projects","type":"extras"},{"doc":"[x] Assets [x] Doc [ ] Export [ ] History [ ] Listen [x] Mutate [ ] Projects [x] Query","ref":"readme.html#supported-endpoints","title":"Sanity - Supported endpoints","type":"extras"}]